////////////Alliance Mission 5////////////////////////////////////
//Objectives:	1) Destroy base			                //
//		2) Return to dropship				//
//////////////////////////////////////////////////////////////////
$missionName = "aa5";
$WarnDistance=3500;

exec("PPcampaignStdLib.cs");

MissionBriefInfo missionBriefInfo
{
   campaign             = "Cardinal Spear Aftermath";
   title                = "Unfair Game";      
   planet               = *IDSTR_PLANET_TITAN;     
   location             = "Foothills east of Eskandani"; 
   dateOnMissionEnd     = 28324985;               
   shortDesc            = "Destroy a cybrid base";
   longDescRichText     = *IDSTR_AA5_BRF;
   media                = "aa5_obj1.bmp";
   successDescRichText  = *IDSTR_AA5_DBRF;
   failDescRichText     = "Mission failed. The base would later become a strongpoint for cybrid resistance.";
   nextMission          = "aa6";
   soundVol             = "";
   successWavFile       = "";
};

MissionBriefObjective missionObjective1         
{
   isPrimary            = true;
   status               = *IDSTR_OBJ_ACTIVE;
   shortTxt             = "Destroy the base";
   longTxt              = "Destroy the supply station. Target generators, communications facilities, and command "
			@"centers.";
   bmpName              = "aa5_obj1.bmp";
};

MissionBriefObjective missionObjective2
{
   isPrimary            = true;
   status               = *IDSTR_OBJ_ACTIVE;
   shortTxt             = "Return to dropship.";
   longTxt              = "Your dropship will remain at Nav Bravo to carry you home. Don't let it be destroyed.";
   bmpName              = "aa5_obj2.bmp";
};

MissionBriefObjective missionObjective3
{
   isPrimary            = false;
   status               = *IDSTR_OBJ_ACTIVE;
   shortTxt             = "Destroy all enemies";
   longTxt              = "Destroy any cybrids you find. Now's our chance to even out the advantage in numbers they gained "
			@"at Eskandani.";
   bmpName              = "aa5_obj3.bmp";
};

MissionBriefObjective missionObjective4
{
   isPrimary            = false;
   status               = *IDSTR_OBJ_ACTIVE;
   shortTxt             = "Salvage supplies.";
   longTxt              = "See what you can dig out of the base. We'll take it along when we leave.";
   bmpName              = "aa5_obj4.bmp";
};

newformation(standard, 0,0,0, -20,-20,0, 20,-20,0, -40,-40,0);

//Map config
$server::HudMapViewOffsetX =  -1000;
$server::HudMapViewOffsetY =  1000;

function player::onAdd(%who)
{
	$THEPLAYER=%who;
}

function vehicle::onAdd(%what)
{
	if(playerManager::vehicleIdToPlayerNum(%what)==$THEPLAYER) {$Player=%what;}
}


function onMissionStart()
{
	$navAlpha= getObjectId("MissionGroup\\Nav\\navAlpha");
	$navBravo= getObjectId("MissionGroup\\Nav\\navBravo");
	$quadOne= getObjectId("MissionGroup\\Cybrids\\Quad1");
	$quadTwo= getObjectId("MissionGroup\\Cybrids\\Quad2");
	$quadOneLeader= getObjectId("MissionGroup\\Cybrids\\Quad1\\Alpha");
	$quadTwoLeader= getObjectId("MissionGroup\\Cybrids\\Quad2\\Alpha");
	$quadOnePath= getObjectId("MissionGroup\\Cybrids\\Paths\\Quad1");
	$quadTwoPath= getObjectId("MissionGroup\\Cybrids\\Paths\\Quad2");
	$Dropship= getObjectId("MissionGroup\\Alliance\\Flyer1");
	$Storage1= getObjectId("MissionGroup\\Base\\cStorage1");
	$Storage2= getObjectId("MissionGroup\\Base\\cStorage2");
	$Storage3= getObjectId("MissionGroup\\Base\\cStorage3");
	$Storage4= getObjectId("MissionGroup\\Base\\cStorage4");
	$Storage5= getObjectId("MissionGroup\\Base\\cStorage5");
	$Storage6= getObjectId("MissionGroup\\Base\\cStorage6");
	$Storage7= getObjectId("MissionGroup\\Base\\cStorage7");
	$Storage8= getObjectId("MissionGroup\\Base\\cStorage8");
	$Storage1Go=false;
	$Storage2Go=false;
	$Storage3Go=false;
	$Storage4Go=false;
	$Storage5Go=false;
	$Storage6Go=false;
	$Storage7Go=false;
	$Storage8Go=false;
	$cybridsLeft= 16;
	$structuresLeft= 15;
	order($quadOneLeader, MakeLeader, true);
	order($quadOne, formation, standard);
	order($quadOneLeader, guard, $quadOnePath);
	order($quadTwoLeader, MakeLeader, true);
	order($quadTwo, formation, standard);
	order($quadTwoLeader, guard, $quadTwoPath);
	clearGeneralOrders();
        cdAudioCycle(newTech, cloudburst, watching);
	schedule("initNav();",1);	//Must wait for player to actually appear on the map
	schedule("initDistanceChecks();",5);
}

function initDistanceChecks()
{
	checkBoundary("leave", $Player, $NavAlpha, $Warndistance, "warn");
	checkBoundary("leave", $Player, $NavAlpha, 4000, "leave");
}

function initNav()
{
	setNavMarker($navAlpha, true, -1);
	setNavMarker($navBravo, false);
}
/////////////////Base Functions////////////////////////////////////////////////////////////////
function base::structure::onDestroyed(%destroyee, %destroyer)
{
	$structuresLeft= $structuresLeft-1;
	if ($structuresLeft==0)
	{
		missionObjective1.status= *IDSTR_OBJ_COMPLETED;
		say(0,0,"GEN_OC01.wav");
		setnavMarker($navAlpha,false);
		setnavMarker($navBravo,true,-1);
		returnToDropship();
	}
}

function base::turret::onDestroyed(%destroyee, %destroyer)
{
	$structuresLeft= $structuresLeft-1;
	if ($structuresLeft==0)
	{
		missionObjective1.status= *IDSTR_OBJ_COMPLETED;
		say(0,0,"GEN_OC01.wav");
		setnavMarker($navAlpha,false);
		setnavMarker($navBravo,true,-1);
		returnToDropship();
	}
}

function storage::structure::onScan(%target, %scanner, %string)
{
	storageAquired(%target);
}

function storage::structure::onDestroyed(%destroyee, %destroyer)
{
	storageLost(%target);
}

function storageAquired(%target)
{
	if (%target==$Storage1) $Storage1Go=true;
	if (%target==$Storage2) $Storage2Go=true;
	if (%target==$Storage3) $Storage3Go=true;
	if (%target==$Storage4) $Storage4Go=true;
	if (%target==$Storage5) $Storage5Go=true;
	if (%target==$Storage6) $Storage6Go=true;
	if (%target==$Storage7) $Storage7Go=true;
	if (%target==$Storage8) $Storage8Go=true;
}

function storageLost(%target)
{
	if (%target==$Storage1) $Storage1Go=false;
	if (%target==$Storage2) $Storage2Go=false;
	if (%target==$Storage3) $Storage3Go=false;
	if (%target==$Storage4) $Storage4Go=false;
	if (%target==$Storage5) $Storage5Go=false;
	if (%target==$Storage6) $Storage6Go=false;
	if (%target==$Storage7) $Storage7Go=false;
	if (%target==$Storage8) $Storage8Go=false;
}
/////////////////Cybrid Functions//////////////////////////////////////////////////////////////
function cybrids::vehicle::onDestroyed(%destroyee, %destroyer)
{
	$cybridsLeft= $cybridsLeft-1;
	if ($cybridsLeft==0)
	{
		missionObjective3.status= *IDSTR_OBJ_COMPLETED;
		say(0,0,"GEN_OC01.wav");
	}
}

function cybrids::vehicle::onArrived(%who, %where)
{
	echo(0,0,"DEBUG: Waypoint "@ %where @" reached by "@ %who, "");
}
/////////////////Alliance Functions////////////////////////////////////////////////////////////
function alli::vehicle::onDestroyed(%destroyee, %destroyer)
{
	setDominantCamera(%destroyer, %destroyee);
	missionObjective2.status= *IDSTR_OBJ_FAILED;
	say(0,0,"mission_fail.wav");
	forceToDebrief();
}

/////////////////Miscellaneous/////////////////////////////////////////////////////////////////
function returnToDropship()
{
	if (getDistance($Player, $dropship) < 75)
	{
	missionObjective2.status= *IDSTR_OBJ_COMPLETED;
	say(0,0,*IDSTR_AA5_DS1,"mission_copm.wav");
	doInventory();
	salvageBase();
	schedule("forceToDebrief();",2.5);
	}
	else schedule("returnToDropship();",1);
}

function doInventory()
{
	InventoryPilotSet(titan, 4, true);	//Dozer

	InventoryVehicleAdjust(titan, 7, 1);	//Myrmidon
	InventoryVehicleAdjust(titan, 14, 1);	//Knight's Basilisk
	InventoryWeaponAdjust(-1, 112, 1);	//Quantum Gun
	InventoryComponentAdjust(-1, 910, 1);	//AGRAV module

	InventoryVehicleAdjust(titan, 3, 1);	//Gorgon
	InventoryWeaponAdjust(titan, 105, 2);	//EMP
	InventoryWeaponAdjust(titan, 119, 2);	//BC
	InventoryComponentAdjust(titan, 113, 1);	//Heavy Turbine Engine
	InventoryComponentAdjust(titan, 204, 1);	//Large Reactor
	InventoryComponentAdjust(titan, 801, 1);	//Imprv Computer
	InventoryComponentAdjust(titan, 305, 1);	//Repulsor Shield
	InventoryComponentAdjust(titan, 927, 1);	//QBM
	InventoryComponentAdjust(titan, 400, 1);	//Basic Sensor
	InventoryComponentAdjust(titan, 811, 1);	//DECM
	InventoryComponentAdjust(titan, 850, 1);	//SAMP
}

function salvageBase()
{
	$stored=0;
	if ($Storage2Go==true) {cybridAddition(); $stored= $stored+1;}
	//Am I using too many functions for this? Oh well, its neater this way
	if ($Storage3Go==true) {tankAddition();$stored= $stored+1;}
	if ($Storage4Go==true) {halfAddition();$stored= $stored+1;}
	if ($Storage5Go==true) {cybridAddition();$stored= $stored+1;}
	if ($Storage7Go==true) {humanAddition();$stored= $stored+1;}
	if ($stored>=3) missionObjective4.status= *IDSTR_OBJ_COMPLETED;
	if ($stored==0) missionObjective4.status= *IDSTR_OBJ_FAILED;	//NOTHING returned
}

function cybridAddition()
{
	InventoryWeaponAdjust(-1, 104, 2);	//TLAS
	InventoryWeaponAdjust(-1, 102, 1);	//HLAS
	InventoryComponentAdjust(-1, 333, 1);	//Theta shield
	InventoryComponentAdjust(-1, 330, 2);	//Epsilon shield
	InventoryComponentAdjust(-1, 141, 1);	//Xi engine
	InventoryComponentAdjust(-1, 807, 1);	//Gamma Computer
	InventoryComponentAdjust(-1, 929, 1);	//CERC
}

function tankAddition()
{
	InventoryWeaponAdjust(-1, 104, 2);	//TLAS
	InventoryWeaponAdjust(-1, 102, 1);	//HLAS
	InventoryComponentAdjust(-1, 333, 1);	//Theta shield
	InventoryComponentAdjust(-1, 330, 2);	//Epsilon shield
	InventoryComponentAdjust(-1, 141, 1);	//Xi engine
	InventoryComponentAdjust(-1, 807, 1);	//Gamma Computer
	InventoryComponentAdjust(-1, 929, 1);	//CERC
	InventoryVehicleAdjust(-1, 6, 1);	//PALA
}

function humanAddition()
{
	InventoryWeaponAdjust(-1, 103, 2);	//CLAS
	InventoryWeaponAdjust(-1, 106, 1);	//ELF
	InventoryWeaponAdjust(-1, 107, 1);	//BLAS
	InventoryWeaponAdjust(-1, 105, 2);	//EMP
	InventoryComponentAdjust(-1, 205, 2);	//Maxim Reactor
}

function halfAddition()
{
	InventoryWeaponAdjust(-1, 103, 1);	//CLAS
	InventoryWeaponAdjust(-1, 107, 1);	//BLAS
	InventoryWeaponAdjust(-1, 105, 1);	//EMP
	InventoryComponentAdjust(-1, 205, 1);	//Maxim Reactor
}
